#include <windows.h>
#include <stdio.h>
#include <wincrypt.h>
#include <tchar.h>

union HASH_UINT128{
	UINT64	u64[2];
	UINT32	u32[4];
	BYTE	u8[16];
	void hex(TCHAR* s){
		_stprintf_s(s, 33, _TEXT("%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x"), u8[0], u8[1], u8[2], u8[3], u8[4], u8[5], u8[6], u8[7], u8[8], u8[9], u8[10], u8[11], u8[12], u8[13], u8[14], u8[15]);
	}
};

bool md5Hashed(char* szPassword, DWORD dwLength, HASH_UINT128* u128){
	HCRYPTPROV hProv = 0;
	HCRYPTHASH hHash = 0;
	if (!CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT)){
		MessageBox(0, _TEXT("CryptAcquireContext"), _TEXT("Error"), MB_OK);
		return false;
	}
	if (!CryptCreateHash(hProv, CALG_MD5, 0, 0, &hHash)){
		MessageBox(0, _TEXT("CryptCreateHash"), _TEXT("Error"), MB_OK);
		CryptReleaseContext(hProv, 0);
		return false;
	}
	if (!CryptHashData(hHash, (BYTE*)szPassword, dwLength, 0)){
		MessageBox(0, _TEXT("CryptCreateHash"), _TEXT("Error"), MB_OK);
		CryptDestroyHash(hHash);
		CryptReleaseContext(hProv, 0);
		return false;
	}
	DWORD dwRead = 16;
	if (!CryptGetHashParam(hHash, HP_HASHVAL, (BYTE*)u128, &dwRead, 0)){
		MessageBox(0, _TEXT("CryptGetHashParam"), _TEXT("Error"), MB_OK);
		CryptDestroyHash(hHash);
		CryptReleaseContext(hProv, 0);
		return false;
	}
	CryptDestroyHash(hHash);
	CryptReleaseContext(hProv, 0);
	return true;
}

void _tmain(void){
	HASH_UINT128 hash;
	TCHAR* pass = _TEXT("abc");
	TCHAR hexs[34];
#ifdef UNICODE
	char sjis[256];
	WideCharToMultiByte(932, 0, pass, -1, sjis, sizeof(sjis), NULL, NULL);
	md5Hashed(sjis, (int)strlen(sjis), &hash);
#else
	md5Hashed(pass, (int)_tcslen(pass), &hash);
#endif
	hash.hex(hexs);
	_tprintf(_TEXT("%s\nmd5 %s\n"), pass,hexs);
}
